#ifndef MISC_H
#define MISC_H
#include "../lib/struct.h"

/*parameters*/
#define INF INT_MAX
#define GUbond -1
#define AUbond -1
#define CGbond -1
#define THRESHOLD 3          // for i and j to basepair, |i-j| >= THRESHOLD
#define RNAfold RNAfold
#define DEBUG 0


/*prototypes for misc.c*/
extern void error(char *);
extern int guPair(char, char);
extern int auPair(char, char);
extern int cgPair(char, char);
extern int a(int, int, char *);
extern int basePair(char, char);
extern int watsonCrick(char, char);
extern data * readInput(char *);
extern list * getBasePairList(char *);
extern int basePiarDisntance(char *, char *);
extern int numBasePairs(char *);
extern int compatible(char *, char *);
extern double evalViennaEnergy(char *, char *);
#endif
