#ifndef STRUCT_H
#define STRUCT_H

/*
 * definition of structure
 */
/*
 * list to stock the base pair
 */
typedef struct item {
	int x;
	int y;
	struct item *next;
} item;
typedef struct list {
	item *first;
	int size;
} list;
/*
 * stock base pairs probability double **P, and nucleaotide unpaired probability double* Q
 * return value of gotDotPlot function
 */
typedef struct PQ {
	double **P;
	double *Q;
	int size;
} PQ;
/*
 * stock all informations got from input file
 * id, RNA sequences, structures, parameters
 */
typedef struct data {
	char **id;
	char **rna;
	char **secStr;
	char **constraint;
	int *alpha;
	int *beta;
	int *Kmax;
	int nb_seq;
} data;
/*
 * prototypes for struct.c
 */
extern char * copyTo_char(char *);
extern list * init_list();
extern int get_list_x(list *, int);
extern int get_list_y(list *, int);
extern int set_list_x(list *, int, int);
extern int set_list_y(list *, int, int y);
extern void add_list_item(list *, int, int);
extern void remove_list_item(list *, int);
extern list * copy_list(list *);
extern int existItemInList(list *, int, int);
extern void print_list(list *);
extern list* set_list(char *);
extern void free_list(list *);
extern PQ * create_PQ(double **, double *, int);
extern void free_PQ(PQ *);
extern void printDouble1D(double *, int);
extern void printDouble2D(double **, int);
extern data * init_data(int);
extern void free_data(data *);
#endif
